Package: ie2miscdata
Title: Irucka Embry's Miscellaneous USGS Data Collection
Version: 1.0.4
Author: Irucka Embry [aut, cre]
Maintainer: Irucka Embry <iembry@ecoccs.com>
Depends: R (>= 3.5.0)
Suggests: install.load, data.table (>= 1.10.2), USA.state.boundaries
        (>= 1.0.1), spatstat.geom, ggplot2 (>= 3.3.4), stringi, mgsub,
        knitr, rmarkdown, reader, sf, rvest, spelling, lubridate, gotop
Description: A collection of Irucka Embry's miscellaneous USGS data sets (USGS
    Parameter codes with fixed values, USGS global time zone codes, and US Air
    Force Global Engineering Weather Data). Irucka created these data sets
    while a Cherokee Nation Technology Solutions (CNTS) United States
    Geological Survey (USGS) Contractor and/or USGS employee.
URL: https://gitlab.com/iembry/ie2miscdata
BugReports: https://gitlab.com/iembry/ie2miscdata/-/issues
License: CC0
Copyright: This software is in the public domain because it contains
        materials that originally came from the United States
        Geological Survey, an agency of the United States Department of
        Interior. For more information, see the official USGS copyright
        policy at
        <https://www.usgs.gov/information-policies-and-instructions/copyrights-and-credits#copyright>
Language: en-US
Encoding: UTF-8
LazyData: true
LazyDataCompression: xz
VignetteBuilder: knitr
RoxygenNote: 7.2.3
NeedsCompilation: no
Packaged: 2023-08-20 22:04:40 UTC; xbyri
Repository: CRAN
Date/Publication: 2023-08-20 22:52:33 UTC
Built: R 4.6.0; ; 2026-04-25 19:39:09 UTC; unix

# ie2miscdata

R data package provides various data sets [USGS Parameter codes with fixed values, USGS global time zone codes, and US Air Force Global Engineering Weather Data] created by Irucka Embry while he was a Cherokee Nation Technology Solutions (CNTS) United States Geological Survey (USGS) Contractor and/or USGS employee.


# Installation from CRAN

```R
install.packages("ie2miscdata")
```


# Package Contents

This package currently contains 70 datasets:

* `pmcode_* (68 data sets)`: Parameter codes with fixed values from Table 26 (USGS)
* `tz_codes`: Global time zone codes and offsets (USGS)
* `weather_results`: Global Engineering Weather Data (US Air Force)



# Vignette Viewing

If you wish to browse the `ie2miscdata` Vignettes, please copy-and-paste the following code into R:

```R
library("ie2miscdata")

utils::browseVignettes("ie2miscdata")
```


# Examples (see an example using the weather_results data set in the vignette)

```R
install.load::load_package("ie2miscdata", "data.table", "lubridate")
# load needed packages using the load_package function from the install.load
# package (it is assumed that you have already installed these packages)

# Please note that lubridate has to be available to view the tz_codes
# Global time zone codes and offsets

data(tz_codes)
head(tz_codes) # first 6 rows


# Global Engineering Weather Data

data(weather_results)
tail(weather_results) # last 6 rows


# USGS Sampling Method (Codes)

data(pmcode_82398)
head(pmcode_82398, 20) # first 20 rows


# USGS Sampler Type, (Codes)

data(pmcode_84164)
tail(pmcode_84164, 10) # last 10 rows
```



# Disclaimer

This software is in the public domain because it contains materials that originally came from the U.S. Geological Survey (USGS), an agency of the United States (US) Department of Interior (DOI). For more information, see the official [USGS copyright policy](https://www.usgs.gov/information-policies-and-instructions/copyrights-and-credits#copyright)

Although this software program has been used by the U.S. Geological Survey (USGS), no warranty, expressed or implied, is made by the USGS or the U.S. Government as to the accuracy and functioning of the program and related program material nor shall the fact of distribution constitute any such warranty, and no responsibility is assumed by the USGS in connection therewith.

This software is provided "AS IS."

#' Extract relevant information from Engineering Weather Data file
#'
#' @param file Engineering Weather Data text file
#'
#' @return data.frame
#'
#'
#' @source
#' \enumerate{
#'    \item r - How can I check if a file is empty? - Stack Overflow answered by Konrad Rudolph and edited by Geekuna Matata on Apr 23 2014. See \url{https://stackoverflow.com/questions/23254002/how-can-i-check-if-a-file-is-empty}.
#'    \item r - Better error message for stopifnot? - Stack Overflow answered by Andrie on Dec 1 2011. See \url{https://stackoverflow.com/questions/8343509/better-error-message-for-stopifnot}.
#' }
#'
#' @import stringi
#' @import reader
#'
#' @export
extractRow6 <- function (file) {

if (file.info(file)$size == 0) {

  stop("Your file is empty. Please try again with a different file.")
# Sources 1 & 2 / only process non-empty files and provide a stop warning if the input file is empty

  } else {

	RDatatmp <- n.readLines(file, n = 10, header = FALSE) # Source 1 / read 10 lines of each file & there is no header

	RDatatmp <- RDatatmp[6]

	RDatatmp <- stri_trim_both(RDatatmp) # trim the left and right
     }
     }

#' Extract relevant information from Engineering Weather Data file
#'
#' @param file Engineering Weather Data text file
#'
#' @return data.table
#'
#' @source
#' \enumerate{
#'    \item r - How can I check if a file is empty? - Stack Overflow answered by Konrad Rudolph and edited by Geekuna Matata on Apr 23 2014. See \url{https://stackoverflow.com/questions/23254002/how-can-i-check-if-a-file-is-empty}.
#'    \item r - Better error message for stopifnot? - Stack Overflow answered by Andrie on Dec 1 2011. See \url{https://stackoverflow.com/questions/8343509/better-error-message-for-stopifnot}.
#'    \item RDocumentation: n.readLines {reader}. See \url{http://www.rdocumentation.org/packages/reader/versions/1.0.5/topics/n.readLines}.
#'    \item r - concatenating rows of a data frame - Stack Overflow answered and edited by adibender on Dec 19 2012. See \url{https://stackoverflow.com/questions/13944078/concatenating-rows-of-a-data-frame/13944315}.
#' }
#'
#' @import reader
#' @import stringi
#'
extractSiteNames <- function (file) {

if (file.info(file)$size == 0) {

  stop("Your file is empty. Please try again with a different file.")
# Sources 1 & 2 / only process non-empty files and provide a stop warning if the input file is empty

  } else {

     RDatatmp <- n.readLines(file, n = 5, header = FALSE) # Source 3 / read 5 lines of each file & there is no header

	RDatatmp <- paste(RDatatmp[1:5], collapse = " ") # Source 4

     RDatatmp <- stri_split_fixed(RDatatmp, pattern = "Latitude", n = 2)[[1]][1]

     }
     }

## ---- warning = FALSE, message = FALSE, out.width = "100%", out.height = "100%"----
install.load::load_package("ie2miscdata", "USA.state.boundaries", "data.table", "ggplot2", "sf", "spatstat.geom")
# load needed packages using the load_package function from the install.load package (it is assumed that you have already installed these packages)


data(weather_results)
# load the weather_results data (containing the site information for USA weather stations)

data(state_boundaries_wgs84)
# load the state_boundaries_wgs84 data from USA.state.boundaries (for the USA map)


## Weather Results

weather_results_map <- copy(weather_results)
# copy the weather_results using data.table

setnames(weather_results_map, 3:4, c("lat", "lon"))
# set the names of columns 3 and 4 using data.table

weather_results_map_sf <- st_as_sf(weather_results_map, coords = c("lon", "lat"), crs = "+proj=longlat +datum=NAD83")
# set the initial projection to longlat using sf

weather_results_map_sf_projected <- st_transform(weather_results_map_sf, "+proj=aea +lat_1=29.5 +lat_2=45.5 +lat_0=23 +lon_0=-96 +x_0=0 +y_0=0 +datum=NAD83 +units=m +no_defs +ellps=GRS80 +towgs84=0,0,0")
# transform the coordinates to match those of the USA_state_boundaries_map data from USA.state.boundaries.data (formerly in USA.state.boundaries)


## USA

USA <- state_boundaries_wgs84
# create the USA object with the same data as state_boundaries_wgs84

USA_projected <- st_transform(USA, "+proj=aea +lat_1=29.5 +lat_2=45.5 +lat_0=23 +lon_0=-96 +x_0=0 +y_0=0 +datum=NAD83 +units=m +no_defs +ellps=GRS80 +towgs84=0,0,0")
# transform the coordinates to match those of the USA_state_boundaries_map data from USA.state.boundaries.data (formerly in USA.state.boundaries)


# As different methods using sf failed to subset the weather map points within the USA, the weather results geometry was subsetted so that spatstat.geom could be used to determine this information

weather_results_map_dt <- as.data.table(st_coordinates(weather_results_map_sf_projected))
# transform the coordinates only to a data.table

setnames(weather_results_map_dt, c("X", "Y"), c("lon", "lat"))
# set the names of columns X and Y using data.table


USA_owin <- spatstat.geom::as.owin(USA_projected)
# transform to Window


inside_USA <- which(spatstat.geom::inside.owin(weather_results_map_dt$lon, weather_results_map_dt$lat, USA_owin))
# determine which locations are within the borders of the USA (including Alaska, Hawai'i, Puerto Rico, and the U.S. Virgin Islands)
# Source 2


weather_results_keep <- weather_results[inside_USA, ]
# keep only the locations within the USA

weather_results_map_keep <- copy(weather_results_keep)
# create a data.table copy of the sites that are kept

setnames(weather_results_map_keep, 3:4, c("lat", "lon"))
# set the names of columns 3 and 4 using data.table

weather_results_map_keep_sf <- st_as_sf(weather_results_map_keep, coords = c("lon", "lat"), crs = "+proj=longlat +datum=WGS84 +ellps=WGS84")
# set the projection to longlat using sf

# plot the map using ggplot2
p <- ggplot() + geom_sf(data = USA, colour = "black", fill = "white")
p <- p + geom_sf(data = weather_results_map_keep_sf, colour = "#3591d1", size = 0.5)
p <- p + labs(x = "", y = "", title = "USA Engineering Weather Sites Map")
print(p)

# source 1
# r - Convert column classes in data.table - Stack Overflow answered by Matt Dowle on Dec 27 2013. See \url{https://stackoverflow.com/questions/7813578/convert-column-classes-in-data-table}.

# source 2
# r - Combine/merge lists by elements names - Stack Overflow answered and edited by flodele on Aug 30 2013. See \url{https://stackoverflow.com/questions/18538977/combine-merge-lists-by-elements-names}.

# source 3
# r - Exporting data of inequal length to CSV - Stack Overflow answered by cory on Sep 17 2014. See \url{https://stackoverflow.com/questions/25899013/exporting-data-of-inequal-length-to-csv/25899712}.

# source 4
# r - Convert column classes in data.table - Stack Overflow answered by Matt Dowle on Dec 27 2013. See \url{https://stackoverflow.com/questions/7813578/convert-column-classes-in-data-table}.


# Reference
# This data is from the ENGINEERING WEATHER DATA PRODUCTS (EWD) CD-ROM, version 1.0, 23 December 1999. CD-ROM provided by the National Climatic Data Center Climate Services Division. See \url{https://www.ncei.noaa.gov/nespls/olstore.prodspecific?prodnum=5005}.



install.load::load_package("data.table", "stringi", "mgsub") # load needed packages


## Using Tabula first
# ./tabpdf2csv.sh
# 2nd part
# tabula -p 1 -a 385.7785714285714,239.33571428571426,438.23571428571427,524.5714285714286 -o $f.csv $f

engr1 <- list.files("./engineering_weather_data", "*.csv$", full.names = TRUE)
engr1name <- basename(file_path_sans_ext(engr1))
engr1name <- mgsub(engr1name, ".pdf", "")


engr2 <- list.files("./engineering_weather_data/eng_weather_data", "*.csv$", full.names = TRUE)
engr2name <- basename(file_path_sans_ext(engr2))
engr2name <- mgsub(engr2name, ".pdf", "")

eng1 <- setNames(lapply(engr1, fread), engr1name) # Source 1
eng2 <- setNames(lapply(engr2, fread), engr2name) # Source 1

# Source 2 begins
l <- list(eng1, eng2)
keys <- unique(unlist(lapply(l, names)))
eng <- setNames(do.call(mapply, c(FUN = c, lapply(l, `[`, keys))), keys)
# Source 2 ends

sapply(names(eng), function(x) write.csv(eng[[x]], file = paste0(x, ".csv"), row.names = FALSE)) # Source 3


# read the created csv files back in
engr3 <- list.files("./engineering_weather_data/csv", "*.csv$", full.names = TRUE)


## Process the results created by both tabula and pdf2text
source("./data-raw/extractWeather.R")
weatherfiles <- list.files(path = "./engineering_weather_data/csv", pattern <- "*.csv$", full.names = TRUE)

getinfo <- lapply(weatherfiles, extractWeather)
weather_results <- rbindlist(getinfo)

weather_results[, "Site name" := gsub("\\.+", " ", weather_results$"Site name")]
setkeyv(weather_results, "Site name")

source("./data-raw/extractSiteNames.R")
listsitenames <- list.files(path = "engineering_weather_data/txt", pattern <- "*.txt$", full.names = TRUE)
sitenames <- lapply(listsitenames, extractSiteNames)
sitenamess <- data.table(as.character((t(rbind(sitenames)))))
setnames(sitenamess, "Site name")
setkeyv(sitenamess, "Site name")


source("./data-raw/extractRow6.R")
row6 <- lapply(listsitenames, extractRow6)
row6s <- data.table(as.character((t(rbind(row6)))))
row6s[, V1 := ifelse(nchar(row6s[[1]]) == 2, row6s[[1]], "")]

sitenamess[, "Site name" := paste(sitenamess$"Site name", row6s$V1, sep = "")]

weather_results[, "Site name" := sitenamess$"Site name"]

# changing column to integer class
# obtain the name of the column based on the column number
change_class1 <- c("WMO No.", "elevation", "Design Value", "Mean Coincident Dry Bulb Temperature")
for (col in change_class1) set(weather_results, j = col, value = as.integer(weather_results[[col]])) # Source 4

setkeyv(weather_results, "Site name")

latss <- grep(" S", weather_results$"lat")
weather_results[latss, lats := -1]
weather_results[, lat := stri_split_fixed(weather_results$"lat", pattern = " ", n = 2, simplify = TRUE)[, 1]]

longs <- grep(" W", weather_results$"lon")
weather_results[longs, long := -1]
weather_results[, lon := stri_split_fixed(weather_results$"lon", pattern = " ", n = 2, simplify = TRUE)[, 1]]

# changing column to numeric class
# obtain the name of the column based on the column number
change_class2 <- c("lat", "lon")
for (col in change_class2) set(weather_results, j = col, value = as.numeric(weather_results[[col]])) # Source 4

weather_results[!is.na(lats), lat := lat * lats]
weather_results[!is.na(long), lon := lon * long]

weather_results[, "lats" := NULL, with = FALSE]
weather_results[, "long" := NULL, with = FALSE]

setnames(weather_results, 3:7, c("Latitude", "Longitude", "Elevation (feet)", "Design Value (degrees F)", "Mean Coincident Dry Bulb Temperature (degrees F)"))

save(weather_results, file = "./data/weather_results.RData")

#' Extract relevant information from Engineering Weather Data file
#'
#' @param file Engineering Weather Data text file
#'
#' @return data.table
#'
#'
#' @source
#' \enumerate{
#'    \item r - How can I check if a file is empty? - Stack Overflow answered by Konrad Rudolph and edited by Geekuna Matata on Apr 23 2014. See \url{https://stackoverflow.com/questions/23254002/how-can-i-check-if-a-file-is-empty}.
#'    \item r - Better error message for stopifnot? - Stack Overflow answered by Andrie on Dec 1 2011. See \url{https://stackoverflow.com/questions/8343509/better-error-message-for-stopifnot}.
#' }
#'
#' @import data.table
#' @import stringi
#' @import mgsub
#'
#' @export
extractWeather <- function (file) {

if (file.info(file)$size == 0) {

  stop("Your file is empty. Please try again with a different file.")
# Sources 1 & 2 / only process non-empty files and provide a stop warning if the input file is empty

  } else {

	RDatatmp <- fread(file)

	RDatatmpnamed <- as.character(names(RDatatmp)[1])
     RDatatmpnamed <- data.frame(as.character(names(RDatatmp)[1]))
     names(RDatatmpnamed) <- "Site name"

     if (ncol(RDatatmp) == 8) {

     RDatatmp[, 2 := NULL, with = FALSE]

     }

     RDatatmphead <- RDatatmp[1:2, c(1, 2), with = FALSE]
     RDatatmptail <- RDatatmp[2, 3:4, with = FALSE]

     RDatatmpuse <- data.table(V1 = RDatatmpnamed, V2 = gsub("WMO No. ", "\\1\\2", RDatatmphead[1, 2, with = FALSE][1]), V3 = gsub("Latitude = ", "\\1\\2", RDatatmphead[1, 1, with = FALSE][1]), V4 = gsub("Longitude = ", "\\1\\2", RDatatmphead[2, 1, with = FALSE][1]), V5 = gsub("Elevation = ", "\\1\\2", RDatatmphead[2, 2, with = FALSE][1]), V6 = RDatatmptail[, 1, with = FALSE], V7 = RDatatmptail[, 2, with = FALSE])
     RDatatmpuse$V4 <- gsub("Longitude =", "\\1\\2", RDatatmphead[2, 1, with = FALSE][1])
     setnames(RDatatmpuse, c("Site name", "WMO No.", "lat", "lon", "elevation", "Design Value", "Mean Coincident Dry Bulb Temperature"))

     RDatatmpuse <- RDatatmpuse[, lapply(.SD, stri_trim_both, pattern = "\\P{Wspace}")] # trim the left and right

     RDatatmpuse[, "elevation" := tolower(RDatatmpuse$"elevation")]
     pats <- c("elevation =", "feet")
     RDatatmpuse[, "elevation" := mgsub(RDatatmpuse$"elevation", pats, "", fixed = FALSE)]

    }
    }

## ---- warning = FALSE, message = FALSE, out.width = "100%", out.height = "100%"----
install.load::load_package("ie2miscdata", "USA.state.boundaries", "data.table", "ggplot2", "sf", "spatstat.geom")
# load needed packages using the load_package function from the install.load package (it is assumed that you have already installed these packages)


data(weather_results)
# load the weather_results data (containing the site information for USA weather stations)

data(state_boundaries_wgs84)
# load the state_boundaries_wgs84 data from USA.state.boundaries (for the USA map)


## Weather Results

weather_results_map <- copy(weather_results)
# copy the weather_results using data.table

setnames(weather_results_map, 3:4, c("lat", "lon"))
# set the names of columns 3 and 4 using data.table

weather_results_map_sf <- st_as_sf(weather_results_map, coords = c("lon", "lat"), crs = "+proj=longlat +datum=NAD83")
# set the initial projection to longlat using sf

weather_results_map_sf_projected <- st_transform(weather_results_map_sf, "+proj=aea +lat_1=29.5 +lat_2=45.5 +lat_0=23 +lon_0=-96 +x_0=0 +y_0=0 +datum=NAD83 +units=m +no_defs +ellps=GRS80 +towgs84=0,0,0")
# transform the coordinates to match those of the USA_state_boundaries_map data from USA.state.boundaries.data (formerly in USA.state.boundaries)


## Southeast region

# subset all southeastern states from state_boundaries_wgs84
southeast <- subset(state_boundaries_wgs84, NAME %in% c("Kentucky", "Florida", "North Carolina", "South Carolina", "Alabama", "Mississippi", "Louisiana", "Georgia", "Virginia", "Tennessee"))
# Source 1

southeast_projected <- st_transform(southeast, "+proj=aea +lat_1=29.5 +lat_2=45.5 +lat_0=23 +lon_0=-96 +x_0=0 +y_0=0 +datum=NAD83 +units=m +no_defs +ellps=GRS80 +towgs84=0,0,0")
# transform the coordinates to match those of the USA_state_boundaries_map data from USA.state.boundaries.data (formerly in USA.state.boundaries)


# As different methods using sf failed to subset the weather map points within the Southeastern USA, the weather results geometry was subsetted so that spatstat.geom could be used to determine this information

weather_results_map_dt <- as.data.table(st_coordinates(weather_results_map_sf_projected))
# transform the coordinates only to a data.table

setnames(weather_results_map_dt, c("X", "Y"), c("lon", "lat"))
# set the names of columns X and Y using data.table


southeast_owin <- spatstat.geom::as.owin(southeast_projected)
# transform to Window



inside_southeast <- which(spatstat.geom::inside.owin(weather_results_map_dt$lon, weather_results_map_dt$lat, southeast_owin))
# determine which locations are within the borders of the Southeastern USA
# Source 2


weather_results_keep <- weather_results[inside_southeast, ]
# keep only the locations within the Southeastern USA

weather_results_map_keep <- copy(weather_results_keep)
# create a data.table copy of the sites that are kept

setnames(weather_results_map_keep, 3:4, c("lat", "lon"))
# set the names of columns 3 and 4 using data.table

weather_results_map_keep_sf <- st_as_sf(weather_results_map_keep, coords = c("lon", "lat"), crs = "+proj=longlat +datum=WGS84 +ellps=WGS84")
# set the projection to longlat using sf

# plot the map using ggplot2
p <- ggplot() + geom_sf(data = southeast, colour = "black", fill = "white")
p <- p + geom_sf(data = weather_results_map_keep_sf, colour = "#3591d1")
p <- p + labs(x = "", y = "", title = "Southeast USA Engineering Weather Sites Map")
print(p)

# source 1
# r - Convert column classes in data.table - Stack Overflow answered by Matt Dowle on Dec 27 2013. See \url{https://stackoverflow.com/questions/7813578/convert-column-classes-in-data-table}.

# Data source \url{https://help.waterdata.usgs.gov/code/tz_query?fmt=html}
# National Water Information System: Help System Time Zone Codes

install.load::load_package("data.table", "rvest") # load needed packages

tz_codes <- read_html("https://help.waterdata.usgs.gov/code/tz_query?fmt=html")
# or 
# tz_codes <- read_html("./data-raw/tz_codes.html")
tz_codes <- html_table(html_nodes(tz_codes, "table"), fill = TRUE)
tz_codes <- tz_codes[[1]]
tz_codes <- setDT(tz_codes)

save(tz_codes, file = "./data/tz_codes.RData")

# source 1
# r - Read multiple tables in from a single text file? - Stack Overflow answered by by0 on Sep 28 2012. See \url{https://stackoverflow.com/questions/7264153/read-multiple-tables-in-from-a-single-text-file}.

# source 2
# loop through all files in a directory, read and save them in an object R - Stack Overflow answered by iembry on Jan 13 15. See \url{https://stackoverflow.com/questions/27911604/loop-through-all-files-in-a-directory-read-and-save-them-in-an-object-r/27912952}.

# source 3
# How to create automatic text file from a list in R? - Stack Overflow answered by Richard Scrivenon Sep 26 14 and edited by Richard Scrivenon Sep 27 14. See \url{https://stackoverflow.com/questions/26068156/how-to-create-automatic-text-file-from-a-list-in-r}.

# Data source \url{https://waterdata.usgs.gov/usa/nwis/qwdata?codes_table26_help}
# Table 26. Parameter codes with fixed values

library("data.table")

# source 1 begins
qwdata_codes <- readLines("./data-raw/qwdata?codes_table26_help.txt")

begin <- grep("^(\\d{5})(\\s)(\\w+)", qwdata_codes)
edge <- vector("integer", length(qwdata_codes))
edge[begin] <- 1
qwdata_codes_names <- qwdata_codes[begin]

edges <- cumsum(edge)

df <- lapply(split(qwdata_codes, edges), function(dat) {

input <- read.delim(textConnection(dat), skip = 1, header = FALSE, fill = TRUE, sep = "$", colClasses = c("character", "numeric", "character"), stringsAsFactors = FALSE)
attr(input, "name") <- dat[1]  # save the name

colnames(input) <- c("Parameter Code", "Fixed Value", "Fixed Text")

input

})

names(df) <- sapply(df, attr, "name")
# source 1 ends

longnames <- names(df)

names(df) <- paste0("pmcode_", substr(names(df), 1, 5))

# source 2 and 3
invisible(lapply(names(df), function(u) {
assign(u, df[[u]])
save(list = u, file = paste0("./data/", u, ".RData"))
}))






parameter <- read.csv("Parameter_Distribution.csv",header=TRUE)
FSTDEC <- parameter$FSTDEC #the FSTDEC parameter from the table
KBOD20 <- parameter$KBOD20
x <- readLines("1.txt")
m <- readLines("1.txt")

for(y in 1:length(KBOD20))
{
  for(i in 1:length(FSTDEC))
{
  regexp <- "KBOD20"
  Lineno <- grep(pattern = regexp, x = x , value = F) #find the place that have the parameter
  newline1 <- paste("    1    3     ",KBOD20[y],"         1     0.101      1.15",sep='')#the newline for the replacement
  m[Lineno+2] <- newline1
  regexp <- "FSTDEC"
  Lineno <- grep(pattern = regexp, x = x , value = F)
  newline1 <- paste("    1   17      ",FSTDEC[i],"         1",sep='')
  x[Lineno+2] <- newline1

filename <- paste("Newfiles\\FSTDEC@",FSTDEC[i],".UCI",sep='')
  writelines(x,m,filename) #generate the file with the new file name
  }
}

original1 <- "00041 Weather"
original2 <- "USGS Weather"
original3 <- "54 rows"
original4 <- "3 variables"
original5 <- "pmcode_00041"

replacement1 <- longnames

dfdim <- sapply(df, dim)
dfdim <- data.frame(sapply(df, dim))
dfrows <- dfdim[1]
dfcols <- dfdim[2]


# https://stackoverflow.com/questions/23474239/writing-multiple-lines-to-a-txt-file-using-r?s=4|0.7866

---
title: "ie2miscdata: Map of USA Engineering Weather Sites"
author: "Irucka Embry, E.I.T. (EcoC²S)"
date: "`r Sys.Date()`"
lang: en-us
urlcolor: blue
output:
  rmarkdown::pdf_document:
    highlight: kate
    toc: true
    latex_engine: xelatex
vignette: >
  %\VignetteIndexEntry{ie2miscdata Map of USA Engineering Weather Sites}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

\bigskip

# Creating a ggplot2 Map of the USA Engineering Weather Sites

```{r, warning = FALSE, message = FALSE, out.width = "100%", out.height = "100%"}
install.load::load_package("ie2miscdata", "USA.state.boundaries", "data.table", "ggplot2", "sf", "spatstat.geom")
# load needed packages using the load_package function from the install.load package (it is assumed that you have already installed these packages)


data(weather_results)
# load the weather_results data (containing the site information for USA weather stations)

data(state_boundaries_wgs84)
# load the state_boundaries_wgs84 data from USA.state.boundaries (for the USA map)


## Weather Results

weather_results_map <- copy(weather_results)
# copy the weather_results using data.table

setnames(weather_results_map, 3:4, c("lat", "lon"))
# set the names of columns 3 and 4 using data.table

weather_results_map_sf <- st_as_sf(weather_results_map, coords = c("lon", "lat"), crs = "+proj=longlat +datum=NAD83")
# set the initial projection to longlat using sf

weather_results_map_sf_projected <- st_transform(weather_results_map_sf, "+proj=aea +lat_1=29.5 +lat_2=45.5 +lat_0=23 +lon_0=-96 +x_0=0 +y_0=0 +datum=NAD83 +units=m +no_defs +ellps=GRS80 +towgs84=0,0,0")
# transform the coordinates to match those of the USA_state_boundaries_map data from USA.state.boundaries.data (formerly in USA.state.boundaries)


## USA

USA <- state_boundaries_wgs84
# create the USA object with the same data as state_boundaries_wgs84

USA_projected <- st_transform(USA, "+proj=aea +lat_1=29.5 +lat_2=45.5 +lat_0=23 +lon_0=-96 +x_0=0 +y_0=0 +datum=NAD83 +units=m +no_defs +ellps=GRS80 +towgs84=0,0,0")
# transform the coordinates to match those of the USA_state_boundaries_map data from USA.state.boundaries.data (formerly in USA.state.boundaries)


# As different methods using sf failed to subset the weather map points within the USA, the weather results geometry was subsetted so that spatstat.geom could be used to determine this information

weather_results_map_dt <- as.data.table(st_coordinates(weather_results_map_sf_projected))
# transform the coordinates only to a data.table

setnames(weather_results_map_dt, c("X", "Y"), c("lon", "lat"))
# set the names of columns X and Y using data.table


USA_owin <- spatstat.geom::as.owin(USA_projected)
# transform to Window


inside_USA <- which(spatstat.geom::inside.owin(weather_results_map_dt$lon, weather_results_map_dt$lat, USA_owin))
# determine which locations are within the borders of the USA (including Alaska, Hawai'i, Puerto Rico, and the U.S. Virgin Islands)
# Source 2


weather_results_keep <- weather_results[inside_USA, ]
# keep only the locations within the USA

weather_results_map_keep <- copy(weather_results_keep)
# create a data.table copy of the sites that are kept

setnames(weather_results_map_keep, 3:4, c("lat", "lon"))
# set the names of columns 3 and 4 using data.table

weather_results_map_keep_sf <- st_as_sf(weather_results_map_keep, coords = c("lon", "lat"), crs = "+proj=longlat +datum=WGS84 +ellps=WGS84")
# set the projection to longlat using sf

# plot the map using ggplot2
p <- ggplot() + geom_sf(data = USA, colour = "black", fill = "white")
p <- p + geom_sf(data = weather_results_map_keep_sf, colour = "#3591d1", size = 0.5)
p <- p + labs(x = "", y = "", title = "USA Engineering Weather Sites Map")
print(p)
```

\bigskip
\bigskip

# Sources

Latitude Longitude Coordinates to State Code in R - Stack Overflow answered by Josh O'Brien on Jan 6 2012 and edited by Josh O'Brien on Jun 18, 2020. See https://stackoverflow.com/questions/8751497/latitude-longitude-coordinates-to-state-code-in-r.  

R-sig-geo - Problem in converting SpatialPolygonsDataFrame to owin object Answer by Roger Bivand on Sep 15, 2006. See https://stat.ethz.ch/pipermail/r-sig-geo/2006-September/001313.html.  

\bigskip
\bigskip

# EcoC^2^S Links

EcoC²S Home -- https://www.ecoccs.com/  
About EcoC²S -- https://www.ecoccs.com/about_ecoc2s.html  
Services -- https://www.ecoccs.com/services.html  
1 Stop Shop -- https://www.ecoccs.com/other_biz.html  
Products -- https://www.questionuniverse.com/products.html  
Media -- https://www.ecoccs.com/media.html  
Resources -- https://www.ecoccs.com/resources.html  
R Trainings and Resources provided by EcoC²S (Irucka Embry, E.I.T.) -- https://www.ecoccs.com/rtraining.html  

\bigskip
\bigskip

# Copyright and License

All R code written by Irucka Embry is distributed under the GPL-3 (or later) license, see the [GNU General Public License {GPL} page](https://www.gnu.org/licenses/gpl-3.0.html).  

All written content originally created by Irucka Embry is copyrighted under the Creative Commons Attribution-ShareAlike 4.0 International License. All other written content retains the copyright of the original author(s).  

This work is licensed under a [Creative Commons Attribution-ShareAlike 4.0 International License](https://creativecommons.org/licenses/by-sa/4.0/).  
